// CGBandObj.h : Declaration of the CCGBandObj

#ifndef __CGBANDOBJ_H_
#define __CGBANDOBJ_H_

#include "resource.h"       // main symbols
#include <atlctl.h>

// Xtra: include UICGBandObj.h header file
#include "UICGBandObj.h"

// Xtra: additional macros
#define MIN_SIZE_X   100
#define MIN_SIZE_Y   100


/////////////////////////////////////////////////////////////////////////////
// CCGBandObj
class ATL_NO_VTABLE CCGBandObj : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<ICGBandObj, &IID_ICGBandObj, &LIBID_CGBANDLib>,
	
	// Xtra: for bug fix, see Q202009 for details
	//public IDispatchImpl<ICGBandObjUI, &IID_ICGBandObjUI, &LIBID_CGBANDLib>,

	// Xtra: additional stuff for this band object
	public CWindowImpl<CCGBandObj>,
	public IObjectWithSiteImpl<CCGBandObj>,
	public IDeskBand,

	//public CComControl<CCGBandObj>,

	public IPersistStreamInitImpl<CCGBandObj>,

	//public IOleControlImpl<CCGBandObj>,
	//public IOleObjectImpl<CCGBandObj>,
	//public IOleInPlaceActiveObjectImpl<CCGBandObj>,
	//public IViewObjectExImpl<CCGBandObj>,
	//public IOleInPlaceObjectWindowlessImpl<CCGBandObj>,
	//public IPersistStorageImpl<CCGBandObj>,
	//public ISpecifyPropertyPagesImpl<CCGBandObj>,
	//public IQuickActivateImpl<CCGBandObj>,
	//public IDataObjectImpl<CCGBandObj>,
	//public IProvideClassInfo2Impl<&CLSID_CGBandObj, NULL, &LIBID_CGBANDLib>,

	public CComCoClass<CCGBandObj, &CLSID_CGBandObj>
{
public:
	CCGBandObj()
	{
		// Xtra: not used in this code
		//m_bWindowOnly = TRUE;

		// Xtra: initialize additional variables
		m_pMainWB   = NULL;	// Pointer to IWebBrowser2 in the main window
		m_pUI       = NULL;
		_pSite      = NULL;
		_hwndParent = NULL;	// Handle to the main window
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CGBANDOBJ)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CCGBandObj)
	COM_INTERFACE_ENTRY(ICGBandObj)
	
	// Xtra: for bug fix, see Q202009 for details
	//COM_INTERFACE_ENTRY(ICGBandObjUI)

	// Additional stuff for band object
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IObjectWithSite)
	COM_INTERFACE_ENTRY_IID(IID_IDeskBand,IDeskBand)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	
	// Xtra: for bug fix, see Q202009 for details
	//COM_INTERFACE_ENTRY2(IDispatch, ICGBandObj)

	/*
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	*/
END_COM_MAP()

BEGIN_PROP_MAP(CCGBandObj)
	// Not used in this code
	//PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	//PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)

	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CCGBandObj)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)

	// Not used in this code
	//CHAIN_MSG_MAP(CComControl<CCGBandObj>)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



/////////////////////////////////////////////////////////////////////////////
// IViewObjectEx
	DECLARE_VIEW_STATUS(0)

/////////////////////////////////////////////////////////////////////////////
// ICGBandObj Methods
public:

/////////////////////////////////////////////////////////////////////////////
// ICGBandObjUI Methods
public:
	// Example method called by the HTML to change the <BODY> background color

	// Xtra: for bug fix, moved to UICGBandObj.h
	//       see Q202009 for details 
	//STDMETHOD(OnClick)(IDispatch* pdispBody, VARIANT varColor)
	//{
	//	CComQIPtr<IHTMLBodyElement> spBody(pdispBody);
	//	if (spBody != NULL)
	//		spBody->put_bgColor(varColor);
	//	return S_OK;
	//}

	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		CAxWindow wnd(m_hWnd);

		HRESULT hr = wnd.CreateControl(IDH_CGBANDOBJ);

		if (SUCCEEDED(hr))
		{
			// Create sub-object - this implements our window.external methods to be    called from HTML
			hr = CComObject<CUICGBandObj>::CreateInstance( &m_pUI );

			if (SUCCEEDED(hr))
			{
				CComQIPtr<IDispatch> pDisp(m_pUI);
				hr = wnd.SetExternalDispatch(pDisp);
			}
		}

		if (SUCCEEDED(hr))
		{
			hr = wnd.QueryControl(IID_IWebBrowser2, (void**)&m_spBrowser);
		}

		return SUCCEEDED(hr) ? 0 : -1;
	}

	CComPtr<IWebBrowser2> m_spBrowser;

// Xtra: below is additional stuff used in this code

/////////////////////////////////////////////////////////////////////////////
// IObjectWithSite Methods
public:
	STDMETHODIMP SetSite(IUnknown* pUnkSite);
	STDMETHODIMP GetSite(REFIID riid, void **ppvSite);

/////////////////////////////////////////////////////////////////////////////
// IDispatch Methods
public:
	STDMETHOD(Invoke)(DISPID, REFIID, LCID, WORD, DISPPARAMS*,
		              VARIANT*, EXCEPINFO*, UINT*);

/////////////////////////////////////////////////////////////////////////////
// IOleWindow Methods
public:
	STDMETHODIMP GetWindow(HWND* phwnd)
	{
		*phwnd = m_hWnd;
		return S_OK;
	}


	STDMETHODIMP ContextSensitiveHelp(BOOL)
	{
		return E_NOTIMPL;
	}

/////////////////////////////////////////////////////////////////////////////
// IDockingWindow, IDeskBand Methods
public:
	STDMETHODIMP ShowDW(BOOL fShow)
	{
		if(m_hWnd)
		{
			if(fShow)
			{
				::ShowWindow(m_hWnd,SW_SHOW);
			}
			else
			{
				::ShowWindow(m_hWnd,SW_HIDE);
			}
		}
		return S_OK;
	}


	STDMETHODIMP CloseDW(unsigned long dwReserved)
	{
		ShowDW(FALSE);
		if(::IsWindow(m_hWnd))
			::DestroyWindow(m_hWnd);
		m_hWnd = NULL;
		return S_OK;
	}


	STDMETHODIMP ResizeBorderDW(const RECT*  prcBorder,
                                     IUnknown* punkToolbarSite,
                                     BOOL      fReserved)
	{
		return E_NOTIMPL;
	}


	STDMETHODIMP GetBandInfo(DWORD dwBandID, DWORD dwViewMode,DESKBANDINFO* pdbi);

	BOOL m_bRequiresSave;

/////////////////////////////////////////////////////////////////////////////
// Private Variables
private:
	CComObject<CUICGBandObj>* m_pUI;

	IWebBrowser2*       m_pMainWB;      // Pointer to IWebBrowser2 in the main window
	IInputObjectSite*   _pSite;
	HWND                _hwndParent;    // Handle to the main window
	DWORD               m_dwBandID;
	DWORD               m_dwViewMode;
	DWORD               m_dwCookie;
};

#endif //__CGBANDOBJ_H_
