// UICGBandObj.h : Declaration of the CUICGBandObj

#ifndef __UICGBANDOBJ_H_
#define __UICGBANDOBJ_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CUICGBandObj
class ATL_NO_VTABLE CUICGBandObj : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CUICGBandObj, &CLSID_UICGBandObj>,
	public IDispatchImpl<IUICGBandObj, &IID_IUICGBandObj, &LIBID_CGBANDLib>
{
public:
	CUICGBandObj()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_UICGBANDOBJ)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CUICGBandObj)
	COM_INTERFACE_ENTRY(IUICGBandObj)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IUICGBandObj
public:
	// Xtra: moved here from CGBandObj.h
	STDMETHOD(OnClick)(IDispatch* pdispBody, VARIANT varColor)
	{
		CComQIPtr<IHTMLBodyElement> spBody(pdispBody);

		if (spBody != NULL)
		{
			spBody->put_bgColor(varColor);
		}

		return S_OK;
	}

	// Xtra: also see CGBand.idl for corresponding modification 
	//       (adding an additional function prototype)
	STDMETHOD(OnNavigate)()
	{
		CComBSTR bstrURL = "www.codeguru.com";
		CComVariant vtEmpty;

		m_pMainWB->Navigate(bstrURL, &vtEmpty, &vtEmpty, &vtEmpty, &vtEmpty);

		return S_OK;
	}

	// Xtra: also see CGBand.idl for corresponding modification
	//       (adding an additional function prototype)
	STDMETHOD(OnShowDocTitle)()
	{
		USES_CONVERSION;

		HRESULT hr = S_OK;

		CComPtr<IDispatch>                             spDisp;
		CComQIPtr<IHTMLDocument2, &IID_IHTMLDocument2> spHTML;

		hr = m_pMainWB->get_Document(&spDisp);

		if (FAILED(hr)) { return hr; }

		//
		// Verify that what we get is a pointer to an IHTMLDocument2
		// interface by querying IHTMLDocument2 interface through a
		// smart pointer.
		//
		spHTML = spDisp;
		if (spHTML)
		{
			BSTR bstrTitle = NULL;
			CComBSTR spBSTRTitle;
			hr = spHTML->get_title(&bstrTitle);

			if (SUCCEEDED(hr))
			{
				HWND pHWND;

				spBSTRTitle = bstrTitle;
				LPCTSTR strTitle = W2CA(spBSTRTitle);

				m_pMainWB->get_HWND((long *)&pHWND);
				::MessageBox(pHWND, strTitle, "CodeGuru Band", MB_ICONWARNING);
			}

			SysFreeString(bstrTitle);
		}

		return S_OK;
	}

	// Xtra: set the pointer to the IWebBrowser2 interface to be automated
	STDMETHOD(SetBrowserCtrl)(IWebBrowser2* pMainWB)
	{
		if (pMainWB)
		{
			m_pMainWB = pMainWB;

			return S_OK;
		}
		
		return S_FALSE;
	}

/////////////////////////////////////////////////////////////////////////////
// Private Variables
private:
	IWebBrowser2* m_pMainWB;  // Pointer to IWebBrowser2 in the main window

};

#endif //__UICGBANDOBJ_H_
